% tests gsfft implementation

addpath('../');

gamma=1/2;      % weight
d=4;            % dimension
N=16;           % refinement
fprintf('Determine the %d-dimensional frequency index set.\n',d);
I=coord_symhc(N,d,gamma);

fprintf('Determine a reconstructing generated set for I.\n');
[r,M]=gs_search(I);

fprintf('Choosing frequency values.\n');
fhat=rand(size(I,1),1)+i*rand(size(I,1),1)-1/2*(1+i);
fprintf('--------------------------------------------\n');

fprintf('Evaluating trigonometric polynomial using GSDFT.\n');
startldft=tic;
f1=gsdft(I,r,M,fhat,'notransp');
tldft=toc(startldft);
fprintf('Evaluating trigonometric polynomial using GSFFT.\n');
startlfft=tic;
f2=gsfft(I,r,M,fhat,'notransp');
tlfft=toc(startlfft);
fprintf('l_1 Error: %1.2e.\n', norm(f1-f2,1));
fprintf('--------------------------------------------\n');
fprintf('Evaluating only one adjoint trigonometric polynomial using GSDFT.\n');
startldft=tic;
fhat1=gsdft(I,r,M,f1,'transp')/M(end);
tldft=tldft+toc(startldft);
fprintf('--------------------------------------------\n');
fprintf('Reconstructing trigonometric polynomial using GSFFT.\n');
startlfft=tic;
fhat2=gsifft(I,r,M,f2);
tlfft=tlfft+toc(startlfft);
fprintf('l_2 Error GSFFT: %1.2e.\n', norm(fhat-fhat2,2));
fprintf('--------------------------------------------\n');
fprintf('Computational times GSDFT: %1.2es.\n', tldft);
fprintf('Computational times GSFFT: %1.2es.\n', tlfft);
