% runtimes plot
% Do not run this script if you are short in time!
% Increase the range of nn in order to get meaningful plots!

d=10;
nn=(2:15);
gamma=0.5.^(1:d);



for n=nn
    I=coord_symhc(1.5^n,d,gamma);
    sizeI(n)=size(I,1);
    tic;
    [z,M]=r1l_cbc_search(I);
    cbct(n)=toc;
    tic;
    [r,Mg]=gs_search(I);
    gsst(n)=toc;
    
    fhat=rand(size(I,1),1)+1i*rand(size(I,1),1)-1/2*(1-1i);
    tic;
    f1=lfft(I,z,M(end),fhat,'notransp');
    fhat1=lfft(I,z,M(end),f1,'transp');
    lfftt(n)=toc;
    
    tic;
    f2=gsfft(I,r,floor(Mg/log2(sizeI(n))),fhat,'notransp');
    fhat2=gsifft(I,r,floor(Mg/log2(sizeI(n))),f2);
    gsfftt(n)=toc;
    fprintf('Values for n=%1.2f computed ...\n',n);
end
    fprintf('--------------------------------.\n');
    fprintf('Plotting the computational times.\n');

    figure(1);
    loglog(nn, sizeI(nn), nn,cbct(nn),nn,gsst(nn),nn,lfftt(nn),nn,gsfftt(nn))
    legend('cardinality of I','runtime of cbc lattice search', 'runtime of generated set search', 'lfft runtimes', 'gsfft runtimes', 'Location','NorthWest');
    title('absolute computational times');

    figure(2);
    loglog(nn,cbct(nn)./sizeI(nn),nn,gsst(nn)./sizeI(nn),nn,lfftt(nn)./sizeI(nn),nn,gsfftt(nn)./sizeI(nn))
    legend('runtime of cbc lattice search', 'runtime of generated set search', 'lfft runtimes', 'gsfft runtimes', 'Location','NorthWest');
    title('computational times relative to the cardinality of I');    
