% tests lfft implementation:

addpath('../');

gamma=1/2;      % weight
d=5;            % dimension
N=16;           % refinement
fprintf('Determine the %d-dimensional frequency index set.\n',d);
I=coord_symhc(N,d,gamma);

fprintf('Determine a reconstructing rank-1 lattice for I.\n');
[z,M]=r1l_cbc_search(I);

fprintf('Choosing frequency values.\n');
fhat=rand(size(I,1),1)+i*rand(size(I,1),1)-1/2*(1+i);
fprintf('--------------------------------------------\n');

fprintf('Evaluating trigonometric polynomial using LDFT.\n');
startldft=tic;
f1=ldft(I,z,M(end),fhat,'notransp');
tldft=toc(startldft);
fprintf('Evaluating trigonometric polynomial using LFFT.\n');
startlfft=tic;
f2=lfft(I,z,M(end),fhat,'notransp');
tlfft=toc(startlfft);
fprintf('l_1 Error: %1.2e.\n', norm(f1-f2,1));
fprintf('--------------------------------------------\n');
fprintf('Reconstructing trigonometric polynomial using LDFT.\n');
startldft=tic;
fhat1=ldft(I,z,M(end),f1,'transp')/M(end);
tldft=tldft+toc(startldft);
fprintf('Reconstructing trigonometric polynomial using LFFT.\n');
startlfft=tic;
fhat2=lfft(I,z,M(end),f2,'transp')/M(end);
tlfft=tlfft+toc(startlfft);
fprintf('l_1 Error LDFT: %1.2e.\n', norm(fhat-fhat1,1));
fprintf('l_1 Error LFFT: %1.2e.\n', norm(fhat-fhat2,1));
fprintf('--------------------------------------------\n');
fprintf('Computational times LDFT: %1.2es.\n', tldft);
fprintf('Computational times LFFT: %1.2es.\n', tlfft);
